# include <iostream>
# include <cstdio>
# include <queue>
# include <vector>

# define infty 123456789
using namespace std;

struct point
{
  int w;
  int t;
  int a;
  int l;
  int v;
  int prio;
};

struct path
{
  vector<point> trg;
  int T;
};

path G[50001];
int T;
int m, n;

bool operator<(const point &a, const point &b)
{
  if (a.prio > b.prio)
    return true;
  return false;
}
bool operator>(const point &a, const point &b)
{
  if (a.prio < b.prio)
    return true;
  return false;
}

bool operator==(const point &a, const point &b)
{
  if (a.prio == b.prio)
    return true;
  return false;
}



int Solve(void)
{
  priority_queue<point> Q;
  G[0].T = 0;
  int pt = 0;
  point w;
  for (vector<point>::iterator p = G[0].trg.begin(); p != G[0].trg.end(); p ++)
    {
      
      w = *p;
      if (p->t == 0)
	w.prio = G[pt].T + p->w;
      else
	{
	  int i = ((G[pt].T - p->a) / p->t);
	  if (((i*p->t)+p->a+p->l) > G[pt].T)
	    w.prio = G[pt].T + p->w;
	  else
	    w.prio = (i+1) * p->t+p->a + p->w;
	}
      Q.push(w);
    }
  while (!Q.empty())
    {
      w = Q.top();
      Q.pop();
      pt = w.v;

      if (G[pt].T > w.prio )
	{
	  G[pt].T = w.prio;

	  if (pt == n - 1)
	      return G[pt].T;
	  for(vector<point>::iterator p = G[pt].trg.begin(); p != G[pt].trg.end(); p ++)
	    {
	      w = *p;
	      if (p->t == 0)
		w.prio = G[pt].T + p->w;
	      else
		{
		  int i = ((G[pt].T - p->a) / p->t);
		  if (((i*p->t)+p->a+p->l) > G[pt].T)
		    w.prio = G[pt].T + p->w;
		  else
		    w.prio = (i+1) * p->t+p->a + p->w;
		}
	      Q.push(w);
	    }
	}
    }

  return -1;
}


      

  
 
int main(void)
{
  int d;
  int v, u, w, t, a, l;
  scanf("%d", &d);
  for(int i = 0; i < d; i++)
    {
      scanf("%d", &n);
      scanf("%d", &m);
      for (int j = 0; j < n; j++)
	G[j].T = infty;
      for (int j = 0; j < m; j++)
	{
	  scanf("%d", &u);
	  scanf("%d", &v);
	  scanf("%d", &w);
	  scanf("%d", &t);
	  scanf("%d", &a);
	  scanf("%d", &l);
	  point p;
	  v--;
	  p.v = v;
	  p.w = w;
	  p.t = t;
	  p.a = a;
	  p.l = l;
	  u--;
	  G[u].trg.push_back(p);

	}
      cout << Solve() << endl;
    }
  return 0;
}


